# Usage Guides

```{toctree}
:maxdepth: 1
:hidden:

generator_scripts
cli_and_build_system
tips_n_tricks
```

These pages provide an overview of how to use the pystencils Source File Generator.
A basic understanding of [pystencils](https://pycodegen.pages.i10git.cs.fau.de/pystencils/index.html)
is required.

```{card} Writing Generator Scripts
:link: guide:generator_scripts
:link-type: ref

Learn about *generator scripts*, the primary usage idiom of *pystencils-sfg*:
Embedd *pystencils*-generated kernels into C++ source files and augment them with
arbitrary C++ glue code.
```

```{card} CLI and Build System Integration
:link: guide:cli
:link-type: ref

Learn how to control code generation from the command line
and how to embedd *pystencils-sfg* into your build system.
```

```{card} Tips and Tricks
:link: guide:tips_n_tricks
:link-type: ref

A collection of various tricks that might come in handy when working with *pystencils-sfg*.
```
